package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.EmpresaEmailEComerceDAO;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.EmpresaEmailEComerce;
import com.rjconsultores.ventaboletos.service.EmpresaEmailEComerceService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("empresaEmailEComerceService")
public class EmpresaEmailEComerceServiceImpl implements EmpresaEmailEComerceService {

	@Autowired
	private EmpresaEmailEComerceDAO empresaEmailEComerceDAO;

	@Override
	public List<EmpresaEmailEComerce> obtenerTodos() {
		return empresaEmailEComerceDAO.obtenerTodos();
	}

	@Override
	public EmpresaEmailEComerce obtenerID(Integer id) {
		return empresaEmailEComerceDAO.obtenerID(id);
	}

	@Override
	@Transactional
	public EmpresaEmailEComerce suscribir(EmpresaEmailEComerce entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return empresaEmailEComerceDAO.suscribir(entidad);
	}

	@Override
	@Transactional
	public EmpresaEmailEComerce actualizacion(EmpresaEmailEComerce entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return empresaEmailEComerceDAO.actualizacion(entidad);
	}

	@Override
	@Transactional
	public void borrar(EmpresaEmailEComerce entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		empresaEmailEComerceDAO.actualizacion(entidad);

	}

	@Override
	public EmpresaEmailEComerce buscarPorEmpresa(Empresa empresa, String tipoOperacao) {
		return empresaEmailEComerceDAO.buscarPorEmpresa(empresa, tipoOperacao);
	}

}
